Object subclass: #PointrelFileSystem
	instanceVariableNames: 'repository rootNode conceptHasSubNode conceptHasName conceptHasContents conceptHasVersionTag workingDirectory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pointrel-Core'!
!PointrelFileSystem commentStamp: 'pdf 7/1/2000 20:17' prior: 0!
Pointrel(TM) Data Repository System
Copyright (c) 2000 Paul D. Fernhout
http://www.pointrel.com

===========================================

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

====================================================================

#This PointrelFileSYstem is for a first try to get going
#implements a simple hierarchical file system using Pointrel
#exercise many PointrelRepository functions, but in a conventional way
#ported from Python version
!


!PointrelFileSystem methodsFor: 'finding' stamp: 'pdf 6/30/2000 18:00'!
findOrAddSubNode: baseNode withName: name
        ^self findOrAddSubNode: baseNode withName: name optimizationDontSearch: 0.
        
! !

!PointrelFileSystem methodsFor: 'finding' stamp: 'pdf 6/30/2000 18:00'!
findOrAddSubNode: baseNode withName: name optimizationDontSearch: optimizationDontSearch
        | subNode nameNode |
        "only set the optimization flag if you are sure the file is not there"
        "print 'baseNode', baseNode"
        optimizationDontSearch == 0 ifTrue: [
            subNode := self findSubNode: baseNode withName: name.
            subNode > 0 ifTrue: [^subNode].
            ].
        "have to add"
        "print 'adding', name"
        repository beginTransaction.
        nameNode := repository triadForName: name.
        subNode := repository addTriadAbstract.
        repository addTriadA: baseNode B: conceptHasSubNode C: subNode.
        repository addTriadA: subNode B: conceptHasName C: nameNode.
        repository endTransaction.
        ^subNode       
        
! !

!PointrelFileSystem methodsFor: 'finding' stamp: 'pdf 7/1/2000 19:55'!
findSubNode: baseNode withName: name
        | subNodes nameNodes nameForNode |
        subNodes :=  repository searchForAllCsA: baseNode B: conceptHasSubNode.
        subNodes do: [:node |
            nameNodes := repository searchForAllCsA: node B: conceptHasName.
            nameNodes do: [:nameNode |
                nameForNode := repository triadString: nameNode.
                "print nameForNode"
                nameForNode = name ifTrue: [
                    "print 'found match for', name"
                    ^node
                     ].
                 ].
             ].
        "not found"
        ^0
! !


!PointrelFileSystem methodsFor: 'storing' stamp: 'pdf 7/1/2000 20:09'!
storeFile: name contents: contents versionTag: versionTag
       ^self storeFile: name contents: contents versionTag: versionTag optimizationDontSearch: 0.! !

!PointrelFileSystem methodsFor: 'storing' stamp: 'pdf 7/1/2000 19:55'!
storeFile: name contents: contents versionTag: versionTag optimizationDontSearch: optimizationDontSearch
        | baseNode subNode nameNode contentsNode versionTriad |
        "only set the optimization flag == 1 if you are sure the file is not there"
        "save simple named file in current directory"
        baseNode := workingDirectory.
        optimizationDontSearch == 0 
            ifTrue: [subNode := self findSubNode: baseNode withName: name]
            ifFalse: [subNode := 0].
        repository beginTransaction.
        subNode == 0 ifTrue: [
            subNode := repository addTriadAbstract.
            "nameNode := repository triadForName: name."
            nameNode := repository addTriadString: name.
            repository addTriadA: baseNode B: conceptHasSubNode C: subNode.
            repository addTriadA: subNode B: conceptHasName C: nameNode.
            ].
        contentsNode := repository addTriadString: contents.
        versionTriad := repository addTriadA: subNode B: conceptHasContents C: contentsNode.
        repository addTriadA: versionTriad B: conceptHasVersionTag C: 0 string: versionTag.
        repository endTransaction.
        ^subNode.       
        
! !

!PointrelFileSystem methodsFor: 'storing' stamp: 'pdf 7/1/2000 18:50'!
storeFileNode: node contents: contents versionTag: versionTag
        | contentsNode versionTriad |
        repository beginTransaction.
        contentsNode := repository addTriadString: contents.
        versionTriad := repository addTriadA: node B: conceptHasContents C: contentsNode.
        repository addTriadA: versionTriad B: conceptHasVersionTag C: 0 string: versionTag.
        repository endTransaction.
        ^contentsNode       
        

! !


!PointrelFileSystem methodsFor: 'accessing' stamp: 'pdf 7/1/2000 20:03'!
repository
  ^repository! !


!PointrelFileSystem methodsFor: 'retrieving' stamp: 'pdf 7/1/2000 19:57'!
retrieveAllVersionsOfFileContents: name
        | baseNode subNode contentsNodes |
        baseNode := workingDirectory.
        subNode := self findSubNode: baseNode withName: name.
        (subNode isNil or: [subNode == 0]) ifTrue: [^nil].
        contentsNodes := repository searchForAllCsA: subNode B: conceptHasContents.
        contentsNodes size == 0 ifTrue: [^nil].
        ^contentsNodes
! !

!PointrelFileSystem methodsFor: 'retrieving' stamp: 'pdf 7/1/2000 18:53'!
retrieveAllVersionsOfFileNodeContents: node
        | contentsNodes result |
        contentsNodes := repository searchForAllCsA: node B: conceptHasContents.
        contentsNodes size == 0 ifTrue: [ ^nil].
        "retrieve all"
        result := OrderedCollection new.
        contentsNodes do: [:contentsNode | result add: (repository triadString: contentsNode).].
        ^result! !

!PointrelFileSystem methodsFor: 'retrieving' stamp: 'pdf 7/1/2000 19:56'!
retrieveFileContents: name
        | baseNode subNode contentsNode |
        baseNode := workingDirectory.
        subNode := self findSubNode: baseNode withName: name.
        (subNode == 0 or: [subNode == nil]) ifTrue: [^nil].
        contentsNode := repository searchForLatestCA: subNode B: conceptHasContents.
        (contentsNode == 0 or: [contentsNode == nil]) ifTrue: [^nil].
        ^repository triadString: contentsNode
        
! !


!PointrelFileSystem methodsFor: 'node accessing' stamp: 'pdf 7/1/2000 18:48'!
getFileNodeContents: node
        | contentsNode |
        contentsNode := repository searchForLatestCA: node B: conceptHasContents.
        (contentsNode == 0 or: [contentsNode isNil]) ifTrue: [ ^nil].
        ^repository triadString: contentsNode.
        
! !

!PointrelFileSystem methodsFor: 'node accessing' stamp: 'pdf 7/1/2000 19:00'!
getNameForNode:  node
        | nameNode |
        nameNode := repository searchForLatestCA: node B: conceptHasName.
        "returns the latest name"
        (nameNode == nil or: [nameNode == 0]) ifTrue: [ ^'NONE - ERROR'].
        ^repository triadString: nameNode.
        
! !

!PointrelFileSystem methodsFor: 'node accessing' stamp: 'pdf 7/1/2000 18:45'!
getParent: node
        | parentNode |
        parentNode := repository searchForLatestAB: conceptHasSubNode C: node.
        ^parentNode
! !

!PointrelFileSystem methodsFor: 'node accessing' stamp: 'pdf 7/1/2000 19:01'!
getSubNodes:  baseNode
        | subNodes |
        subNodes := repository searchForAllCsA: baseNode B: conceptHasSubNode.
        ^subNodes

                
! !

!PointrelFileSystem methodsFor: 'node accessing' stamp: 'pdf 7/1/2000 18:47'!
isFile: node
        | contentsNode |
        contentsNode := repository searchForLatestCA: node B: conceptHasContents.
        "contentsNode will be a value if present, or 0 or nil if not"
        contentsNode isNil ifTrue: [^false].
        ^contentsNode ~= 0
! !


!PointrelFileSystem methodsFor: 'printing' stamp: 'pdf 7/1/2000 19:35'!
indentForLevel: level
        | result |
        level == 0 ifTrue: [^''].
        result := String new.
        "should use stream"
        1 to: level do: [:i| result := result, '  '].
        ^result
! !

!PointrelFileSystem methodsFor: 'printing' stamp: 'pdf 7/1/2000 19:33'!
printDirectoryTree
       self printDirectoryTree: 0 level: 0.! !

!PointrelFileSystem methodsFor: 'printing' stamp: 'pdf 7/1/2000 19:59'!
printDirectoryTree: inputNode level: inputLevel
        "use 0 and 0 to go from the top"
        "recursive"
        | node level nameNodes subNodes |
        node := inputNode.
        level := inputLevel.
        node == 0 ifTrue: [node := rootNode].
        node ~= rootNode ifTrue: [
            nameNodes := repository searchForAllCsA: node B: conceptHasName.
            "print all names -- usually just one"
            nameNodes do: [:nameNode |
                "print 'nameNode', nameNode."
                "print self repository triadString: nameNode."
                Transcript show:  (self indentForLevel: level) , '"' , (repository triadString: nameNode) , '"'; cr.
                ].
            ].
        subNodes := repository searchForAllCsA: node B: conceptHasSubNode.
        subNodes do: [:subNode | self printDirectoryTree: subNode level: level + 1. ].! !


!PointrelFileSystem methodsFor: 'directory changing' stamp: 'pdf 7/1/2000 19:38'!
changeWorkingDirectory: path
        | elements subNode |
        elements := self split: path at:  '\'.
        "print elements"
        subNode := rootNode.
        elements do: [:name|
            name size > 0 ifTrue: [subNode := self findOrAddSubNode: subNode withName: name.].
            ].
        "print subnode"
        workingDirectory := subNode.
! !

!PointrelFileSystem methodsFor: 'directory changing' stamp: 'pdf 7/1/2000 19:39'!
split: path at:  characterString
        ^path findTokens: characterString.
! !


!PointrelFileSystem methodsFor: 'initializing and releasing' stamp: 'pdf 7/1/2000 19:53'!
initialize
        repository := PointrelRepository new.
        repository openFiles.
        
        "define some needed constant nodes"
        rootNode := repository triadForConcept: 'Pointrel file system root node'.
        conceptHasSubNode := repository triadForConcept: 'has subnode'.
        conceptHasName := repository triadForConcept: 'has name'.
        conceptHasContents := repository triadForConcept: 'has contents'.
        conceptHasVersionTag := repository triadForConcept: 'has version tag'.
        workingDirectory := rootNode.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PointrelFileSystem class
	instanceVariableNames: ''!

!PointrelFileSystem class methodsFor: 'instance creating' stamp: 'pdf 6/30/2000 12:12'!
new
^super new initialize! !


!PointrelFileSystem class methodsFor: 'testing' stamp: 'pdf 7/1/2000 20:22'!
test      
    | s versions |
    "run this multiple times to see file contents versions accumulate"

    "You need to have first created the repository files using the test method in PointrelRepository zapAndTest."

    "PointrelFileSystem test."

    s := PointrelFileSystem new.
    s changeWorkingDirectory: '\hello\world\again'.
    s changeWorkingDirectory: '\hello\world\here'.
    s changeWorkingDirectory: '\hello\world\there'.
    s changeWorkingDirectory: '\hello\world\everwhere'.
    s changeWorkingDirectory: '\hello\there'.
    s changeWorkingDirectory: 'test1'.
    s changeWorkingDirectory: 'test2'.
    Transcript show: 'about to print tree'; cr.
    s printDirectoryTree.
    Transcript show: (s storeFile: 'contents0001.txt' contents: 'This is the contents of contents0001.txt' versionTag: '0.0.1 (Test)') printString; cr.
    Transcript show: (s storeFile: 'contents0001.txt' contents: 'And now for something completely different   ' versionTag: '0.0.2 (Test)') printString; cr.
    Transcript show: (s retrieveFileContents: 'contents0001.txt'); cr.
    versions := s retrieveAllVersionsOfFileContents: 'contents0001.txt'.
    Transcript show: versions printString; cr.
    "prints versions most recent to least recent"
    versions do: [:each |  Transcript show: (s repository triadString: each); cr.].
        ! !


Object subclass: #PointrelRepository
	instanceVariableNames: 'triadFileName indexLastFileName indexPreviousFileName stringFileName triadFile indexLastFile indexPreviousFile stringFile nameTreeBase definesSymbolNodeConcept nameForConceptConcept zeroArray3 triadArray4 previousArray3 signatureString4 nameCache conceptCache '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pointrel-Core'!
!PointrelRepository commentStamp: 'pdf 7/3/2000 14:52' prior: 0!
Pointrel(TM) Data Repository System
Copyright (c) 2000 Paul D. Fernhout
http://www.pointrel.com

===========================================

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

====================================================================

This code defines a repository for Pointrel objects.
Pointrel Objects consist of these fields:
A B C S
A, B, and C can be pointers to other Pointrel objects.
S is an optional string.
Note that strings can also be encoded in triads;
The structure here is for efficiency on circa 2000AD hardware.
 
This program implements the simplest concepts in Pointrel.
Pointrel is primarily an information storage architecture.
The basic concept is a triad. A triad is an object with three links and an optional string. 
These links can point to other triads.  
This allows one to build arbitrarily complex structures,
as well as add to these structures at any time.

Triad 0 is reserved as a null entity.
Triads 1 - 256 are reserved to represent characters in the ascii character set.
Triads 257 - 1023 are reserved to represent base shared concepts.

These values may be adjusted in future versions, most likely being expanding the range for
shared concepts up to several millions or so.

#ported from Python version 

Concept and name caches added. 
These may not work in some cases if deleting names or concepts, or if having one name describe multiple concepts. Use the uncached method calls then, or flush the caches.!


!PointrelRepository methodsFor: 'initializing and releasing' stamp: 'pdf 7/3/2000 14:35'!
initialize
	| directoryName |
	"directoryName = os.getcwd() , os.sep"
	directoryName := '.\'.
	triadFileName := directoryName , 'PointrelRepository.triads'.
	indexLastFileName := directoryName , 'PointrelRepository.indexLast'.
	indexPreviousFileName := directoryName , 'PointrelRepository.indexPrevious'.
	stringFileName := directoryName , 'PointrelRepository.strings'.

     "array of three zeroes for use in creating triads"
     zeroArray3 := Array new: 3.
     zeroArray3 at: 1 put: 0.
     zeroArray3 at: 2 put: 0.
     zeroArray3 at: 3 put: 0.

     "array used repeatedly to write triad"
     triadArray4 := Array new: 4.

     "array used repeatedly to write previous file"
     previousArray3 := Array new: 3.

     "the signature used for wtiting out strings -- '$P\r\n' "
     signatureString4 := String new: 4.
     signatureString4 at: 1 put: $$.
     signatureString4 at: 2 put: $P.
     signatureString4 at: 3 put: Character cr.
     signatureString4 at: 4 put: Character lf.

     "caching"
     nameCache := Dictionary new.
     conceptCache := Dictionary new.
     ! !


!PointrelRepository methodsFor: 'transaction handling' stamp: 'pdf 7/3/2000 18:23'!
beginTransaction

"
    #transaction support stubs
    #bracket code which must make multipel changes at once with these
    #eventually these may be implimented
    Note that transcations must be nestable!!
"
! !

!PointrelRepository methodsFor: 'transaction handling' stamp: 'pdf 6/17/2000 20:54'!
endTransaction

"
    #transaction support stubs
    #bracket code which must make multipel changes at once with these
    #eventually these may be implimented
"

! !


!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 7/3/2000 20:06'!
addCommonSharedConcepts

        "define some coming concepts related to naming that all Pointrel repositories should share"
        | nameNode |
        "put in the first null triad -- although zero can mean not found"
        self addTriadA: 0 B: 0 C: 0 string: 'Pointrel Repository Strings'.

        "reserve 256 characters"
        "entityForCharacter and characterForEntity needs to agree with this"
        0 to: 255 do: [:i |
            self addTriadA: 0 B: 0 C: 0 string: (String with: i asCharacter).
            ].

        "put in support for naming"

        "node = 257"
        nameTreeBase := self addTriadString: 'comment: name tree base'.
        "node = 258"
        definesSymbolNodeConcept := self addTriadString: 'comment: "defines symbol node" concept'.
        "node = 259"
        nameForConceptConcept := self addTriadString: 'comment: "name for concept" concept'.

        nameTreeBase ~= 257 ifTrue: [self halt: 'concept out of place'.].
        definesSymbolNodeConcept ~= 258 ifTrue: [self halt: 'concept out of place'].
        nameForConceptConcept ~= 259 ifTrue: [self halt: 'concept out of place'].
        
        "reserve the rest up to 1024" 
        [self triadCount < 1024] whileTrue:
            [self addTriadString: 'reserved ',  self triadCount printString].

        "build initialized self-referential structure  relate to names and concepts"
        "done after reservations as name tree elements take up space"    
        
        nameNode := self triadForName: 'name for concept'.
        self addTriadA: nameNode B: nameForConceptConcept C: nameForConceptConcept.

        nameNode := self triadForName: 'defines symbol node'.
        self addTriadA: nameNode B: nameForConceptConcept C: definesSymbolNodeConcept.

        "strictly speaking, nameTreeBase is an object not a concept"
        "nameNode := self triadForName: 'name tree base'."
        "self addTriadA: nameNode B: nameForConceptConcept C: self nameTreeBase."
        
        "maybe put in support for file system"
        
        "maybe put in support for other common concepts"
             
            
        
! !

!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 7/3/2000 15:00'!
concept: aString

^self triadForConcept: aString! !

!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 7/3/2000 19:42'!
defineCommonSharedConceptConstants

nameTreeBase := 257.
definesSymbolNodeConcept := 258.
nameForConceptConcept := 259.
! !

!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 7/3/2000 15:00'!
name: aString

^self triadForName: aString! !

!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 6/30/2000 10:26'!
nameForTriad: nameNode

        ^ self triadString: nameNode.! !

!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 7/3/2000 14:50'!
triadForConcept: name 
	"
find a triad for a concept which may have multiple names"
     "use a cache to minimize disk accesses"
	"throws exception if more than one concept associated with a name"
     "if concept not found, add it"
	"print triadForConcept: entered"
	| conceptNode cachedConcept |
	cachedConcept := self conceptFromCache: name.
	cachedConcept notNil ifTrue: [^cachedConcept].
	conceptNode := self triadForConceptUncached: name.
	"print triadForConcept: added concept , name, conceptNode"
	self addToCacheConcept: name node: conceptNode.
	^ conceptNode! !

!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 7/3/2000 14:48'!
triadForConceptUncached: name

   | nameNode concepts conceptNode |
   "
find a triad for a concept which may have multiple names "     
    "throws exception if more than one concept associated with a name"

        "print triadForConcept: entered"

        nameNode := self triadForName: name.
        "print triadForConcept: nameNode, name, nameNode"

        concepts := self searchForAllCsA: nameNode B: nameForConceptConcept.
        concepts size == 1 ifTrue: [
            "print triadForConcept: found , name, conceptNode"
            ^concepts first.
            ].
        concepts size > 1 ifTrue: [self halt: 'More than one many concept attached to a name', name].

        self beginTransaction.
        conceptNode := self addTriadAbstract.
        self addTriadA: nameNode B: nameForConceptConcept C: conceptNode.
        self endTransaction.

        "print triadForConcept: added concept , name, conceptNode"
        ^conceptNode 
        

     ! !

!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 7/3/2000 14:50'!
triadForName: name 
	"searches for a unique name using tree of characters"
     "use a cache to minimeze disk accesses"
	"if name not found, adds it"
	| node cachedName |
	cachedName := self nameFromCache: name.
	cachedName notNil ifTrue: [^cachedName].
	node := self triadForNameUncached: name.
	self addToCacheName: name node: node.
	^ node! !

!PointrelRepository methodsFor: 'concept handling' stamp: 'pdf 7/3/2000 14:47'!
triadForNameUncached: name

   "searches for a unique name using tree of characters"
   "not very efficient but easy to impliment"
   "if name not found, adds it "
   | previousNode partialString node characterNode |
 
        previousNode := nameTreeBase.
        partialString := String new.
        node := nil.

        name do: [:c |
            partialString := partialString , (String with: c).
            characterNode := self entityForCharacter: c.
            node := self searchForLatestCLinkA: previousNode B: characterNode.
            node isNil ifTrue: [
                "print 'triadForName: adding a node for ', partialString"
                node := self addTriadA: previousNode B: characterNode C: definesSymbolNodeConcept string: partialString.
                ].
            "print 'triadForName: found match ', partialString, node"
            previousNode := node.
            ].

        "print 'triadForName: ', name, node"
        ^node     
    ! !


!PointrelRepository methodsFor: 'removal handling' stamp: 'pdf 7/3/2000 19:00'!
checkIfMarkedRemoved: triad
| markTriad |
"for covenience, checks if a triad is marked as removed"
"this functionality could be moved into the lower level functions at a speed penalty for common operations"
"this is one way to 'delete' data, even though it is still there."
markTriad := self searchForTriadOrNoneA: triad B: (self concept: 'was removed') C: 0.
^markTriad ~= nil.! !

!PointrelRepository methodsFor: 'removal handling' stamp: 'pdf 7/3/2000 18:50'!
markRemoved: triad
"for covenience, marks a triad as removed"
"this is one way to 'delete' data, even though it is still there."
^self addTriadA: triad B: (self concept: 'was removed') C: 0.! !


!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 7/3/2000 18:57'!
search: triadIndex offset: offset

        "return list of triad with this triad in the defined (offset = 0, 4, 8 = A, B, C) slot  "
        | previous resultArray |
        previous := self searchStart: triadIndex offset: offset.
        resultArray := OrderedCollection new.
        [previous > 0] whileTrue: [
            resultArray add: previous.
            previous := self searchNext: previous offset: offset.
            ].
        ^resultArray.

"in functions to search - probably don't need version that matches string"

        
! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:31'!
searchForAllALinksB: b C: c

	| matches result bs |
	matches := self search: c offset: 8.
	result := OrderedCollection new.
	matches do: 
		[:triadIndex | 
		bs := self triadB: triadIndex.
		b == bs ifTrue: [result add: triadIndex]].
	^ result! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:34'!
searchForAllAsB: b C: c 
	| links |
	links := self searchForAllALinksB: b C: c.
	^ links collect: [:each | self triadA: each]! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:31'!
searchForAllBLinksA: a C: c

	| matches result cs |
	matches := self search: a offset: 0.
	result := OrderedCollection new.
	matches do: 
		[:triadIndex | 
		cs := self triadC: triadIndex.
		c == cs ifTrue: [result add: triadIndex]].
	^ result! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:35'!
searchForAllBsA: a C: c

	| links |
	links := self searchForAllBLinksA: a C: c.
	^ links collect: [:each | self triadB: each]! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:29'!
searchForAllCLinksA: a B: b 
	| matches result bs |
	matches := self search: a offset: 0.
	result := OrderedCollection new.
	matches do: 
		[:triadIndex | 
		bs := self triadB: triadIndex.
		b == bs ifTrue: [result add: triadIndex]].
	^ result! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:35'!
searchForAllCsA: a B: b

	| links |
	links := self searchForAllCLinksA: a B: b.
	^ links collect: [:each | self triadC: each]! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:44'!
searchForLatestAB: b C: c

  |result|
  result :=  self searchForLatestALinkB: b C: c.
  ^result isNil ifTrue: [nil] ifFalse: [self triadA: result].! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:40'!
searchForLatestALinkB: b C: c

        |triadIndex bs|
        triadIndex := self searchStart: c offset: 8.
        [triadIndex ~~ 0] whileTrue: [
            bs := self triadB: triadIndex.
            b == bs ifTrue: [^triadIndex].
            triadIndex := self searchNext: triadIndex  offset: 8.
            ].
        ^nil.! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:44'!
searchForLatestBA: a C: c

  |result|
  result :=  self searchForLatestBLinkA: a C: c.
  ^result isNil ifTrue: [nil] ifFalse: [self triadB: result].! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 7/3/2000 20:26'!
searchForLatestBLinkA: a C: c

        |triadIndex cs|
        triadIndex := self searchStart: a offset: 0.
        [triadIndex ~~ 0] whileTrue: [
            cs := self triadC: triadIndex.
            c == cs ifTrue: [^triadIndex].
            triadIndex := self searchNext: triadIndex offset: 0.
            ].
        ^nil.! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 7/3/2000 20:26'!
searchForLatestCA: a B: b

  |result|
  result := self searchForLatestCLinkA: a B: b.
  ^result isNil ifTrue: [nil] ifFalse: [self triadC: result].! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 7/3/2000 20:26'!
searchForLatestCLinkA: a B: b
        |triadIndex bs|
        triadIndex := self searchStart: a offset: 0.
        [triadIndex ~~ 0] whileTrue: [
            bs := self triadB: triadIndex.
            b == bs ifTrue: [^triadIndex].
            triadIndex := self searchNext: triadIndex offset: 0.
            ].
        ^nil.
! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/29/2000 20:26'!
searchForTriadOrAddA: a B: b C: c

       |result|
       result := self searchForTriadOrNoneA: a B: b C: c.
       ^result isNil 
            ifTrue: [self addTriadA: a B: b C: c string: nil] 
            ifFalse: [result].! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 7/3/2000 20:27'!
searchForTriadOrNoneA: a B: b C: c

        |matches|
        matches := self search: a offset: 0.
        matches do: [:triadIndex |
            (a == (self triadA: triadIndex) and: [b == (self triadB: triadIndex) and: [c == (self triadC: triadIndex)]])
                ifTrue: [^triadIndex].
            ].
        ^nil.! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/30/2000 08:26'!
searchNext: previous offset: offset
        "offset can be 0, 4, or 8 for A, B, or C respectively"
        ^self readIntegerFromFile: indexPreviousFile position: previous * 12 + offset.


! !

!PointrelRepository methodsFor: 'triad searching' stamp: 'pdf 6/30/2000 08:26'!
searchStart: triadIndex offset: offset

        "offset can be 0, 4, or 8 for A, B, or C respectively"
        ^self readIntegerFromFile: indexLastFile position: triadIndex * 12 + offset.
! !


!PointrelRepository methodsFor: 'repository handling' stamp: 'pdf 6/8/2000 22:20'!
checkIndexes
      "not implemented yet"
self halt.
! !

!PointrelRepository methodsFor: 'repository handling' stamp: 'pdf 6/8/2000 22:20'!
rebuildIndexes
      "not implemented yet"
self halt.
! !

!PointrelRepository methodsFor: 'repository handling' stamp: 'pdf 6/30/2000 08:30'!
triadCount
        "function to return information about repository"
        | triadIndex |
        triadFile setToEnd.
        triadIndex := triadFile position >> 4.  
        ^triadIndex
! !


!PointrelRepository methodsFor: 'triad field accessing' stamp: 'pdf 6/30/2000 08:15'!
triadA: triadIndex
    ^self readIntegerFromFile: triadFile position: triadIndex * 16 + 0.

! !

!PointrelRepository methodsFor: 'triad field accessing' stamp: 'pdf 6/30/2000 08:51'!
triadABC: triadIndex
    "returns an array of three integers"
    ^self readIntegerArrayFromFile: triadFile position: triadIndex * 16 length: 3.

        ! !

!PointrelRepository methodsFor: 'triad field accessing' stamp: 'pdf 6/30/2000 11:34'!
triadABCString: triadIndex

    "return an array of three integers and a string"
    | result |
    "get array of four values, where last is string location of stringFile"
    result := self readIntegerArrayFromFile: triadFile position: triadIndex * 16 length: 4.

    "replace string location with the string itself"
    result at: 4 put: (self readString: (result at: 4)).
    ^result.
   ! !

!PointrelRepository methodsFor: 'triad field accessing' stamp: 'pdf 6/30/2000 08:15'!
triadB: triadIndex

    ^self readIntegerFromFile: triadFile position: triadIndex * 16 + 4.! !

!PointrelRepository methodsFor: 'triad field accessing' stamp: 'pdf 6/30/2000 08:15'!
triadC: triadIndex

    ^self readIntegerFromFile: triadFile position: triadIndex * 16 + 8.! !

!PointrelRepository methodsFor: 'triad field accessing' stamp: 'pdf 6/30/2000 08:49'!
triadString: triadIndex

        | stringPosition |
        stringPosition := self readIntegerFromFile: triadFile position: triadIndex * 16 + 12.
        stringPosition == 0 ifTrue: [^nil].
        ^self readString: stringPosition.! !


!PointrelRepository methodsFor: 'triad building' stamp: 'pdf 6/17/2000 20:48'!
addTriadA: a B: b C: c

^self addTriadA: a B: b C: c string: nil.! !

!PointrelRepository methodsFor: 'triad building' stamp: 'pdf 6/30/2000 11:31'!
addTriadA: a B: b C: c string: string

        "Ideally, all the files writes in this function should proceed together atomically"

        | triadIndex stringLocation stringSize previousA previousB previousC |

        triadIndex := self triadCount.
        "Transcript show: triadIndex printString."

        "write the string first to ensure it is there before making triad"
        string notNil ifTrue: [
            "get string data location"
            stringFile setToEnd.
            stringLocation := stringFile position  + 8.

            "write signature"
            self writeString: signatureString4 toFile: stringFile .

            "write index"
            self writeInteger: stringLocation toFile: stringFile.
            
            "write size"
            stringSize := string size.
            self writeInteger: stringSize toFile: stringFile.

            "write string"
            self writeString: string toFile: stringFile.
            ]
        ifFalse: [stringLocation := 0].

        a < triadIndex 
            ifTrue: [previousA := self findLast: a offset: 0]
            ifFalse: [previousA := 0].
        b < triadIndex
            ifTrue: [previousB := self findLast: b offset: 4]
            ifFalse: [previousB := 0].
        c < triadIndex
            ifTrue: [previousC := self findLast: c offset: 8]
            ifFalse: [previousC := 0].
            
        "print a, b, c, stringLocation"

        triadArray4 at: 1 put: a.
        triadArray4 at: 2 put: b.
        triadArray4 at: 3 put: c.
        triadArray4 at: 4 put: stringLocation.

        previousArray3 at: 1 put: previousA.
        previousArray3 at: 2 put: previousB.
        previousArray3 at: 3 put: previousC.
        
        "seek isn't needed for triadFile if at end from getting size"
        self writeIntegerArrayToFile: triadFile position: (triadIndex << 4) integerArray: triadArray4.

        self writeIntegerArrayToFile: indexPreviousFile position: triadIndex * 12 integerArray: previousArray3.

        "now update lastFile"
        self setLast: a offset: 0 newValue: triadIndex.
        self setLast: b offset: 4 newValue: triadIndex.
        self setLast: c offset: 8 newValue: triadIndex.
        
        "go to end of last file and put in zeros -- as no one can reference this yet"
        "ignore possibility of self-reference of a triad"
        "in Python: seek to location vs. seek to end seems to be needed --otherwise adding extra triple"
        self writeIntegerArrayToFile: indexLastFile position: triadIndex * 12 integerArray: zeroArray3.
        
        self flushFiles.
        
        ^triadIndex
                
! !

!PointrelRepository methodsFor: 'triad building' stamp: 'pdf 6/17/2000 20:48'!
addTriadAbstract

^self addTriadA: 0 B: 0 C: 0 string: nil.! !

!PointrelRepository methodsFor: 'triad building' stamp: 'pdf 6/17/2000 20:49'!
addTriadString: string

^self addTriadA: 0 B: 0 C: 0 string: string.! !

!PointrelRepository methodsFor: 'triad building' stamp: 'pdf 6/30/2000 08:10'!
findLast: triadIndex offset: offset

        "offset should be 0, 4, 8 for A, B, and C fields respectively"
        ^ self readIntegerFromFile: indexLastFile position: triadIndex * 12 + offset.

        
! !

!PointrelRepository methodsFor: 'triad building' stamp: 'pdf 6/30/2000 08:13'!
setLast: triadIndex offset: offset newValue: newValue

        "offset should be 0, 4, 8 for A, B, and C respectively"
        self writeIntegerToFile: indexLastFile position: triadIndex * 12 + offset integer: newValue.! !


!PointrelRepository methodsFor: 'character handling' stamp: 'pdf 6/17/2000 20:47'!
characterForEntity: node

((node < 1) or: [node > 256]) ifTrue: [Transcript show: 'unrecognized character conversion'. self halt. ^nil].
^String with: ((node - 1) asCharacter).

! !

!PointrelRepository methodsFor: 'character handling' stamp: 'pdf 6/30/2000 11:19'!
entityForCharacter: c

^ 1 + c asInteger
! !


!PointrelRepository methodsFor: 'file reading and writing' stamp: 'pdf 6/30/2000 11:16'!
readIntegerArrayFromFile: file position: position length: length
  | array |
  file position: position.
  array := Array new: length.
  1 to: length do: [:i |
      "stored in network byte order"
      array at: i put: file nextInt32.
      ].
    ^array! !

!PointrelRepository methodsFor: 'file reading and writing' stamp: 'pdf 6/30/2000 11:16'!
readIntegerFromFile: file position: position
  file position: position.
  "stored in network (big endian) byte order"
  ^file nextInt32.
! !

!PointrelRepository methodsFor: 'file reading and writing' stamp: 'pdf 7/4/2000 09:17'!
readString: position

        | length string |
        position == 0 ifTrue: [^nil].
        length := self readIntegerFromFile: stringFile position: position.
       " length > 10000 ifTrue: [self halt: 'Debug - string longer than test routines expected']."
        string := stringFile next: length.
        ^string asString! !

!PointrelRepository methodsFor: 'file reading and writing' stamp: 'pdf 6/30/2000 11:10'!
writeInteger: value toFile: file
  "use current position"
  "should be in network byte order -- is this in network byte order?"
  file nextInt32Put: value.
  ! !

!PointrelRepository methodsFor: 'file reading and writing' stamp: 'pdf 6/30/2000 11:10'!
writeIntegerArrayToFile: file position: position integerArray: array
  file position: position.
  array do: [:each |
      "should be in network byte order -- is this in network byte order?"
      file nextInt32Put: each.
      ].! !

!PointrelRepository methodsFor: 'file reading and writing' stamp: 'pdf 6/30/2000 11:10'!
writeIntegerToFile: file position: position integer: value
  file position: position.
  "should be in network byte order -- is this in network byte order?"
  file nextInt32Put: value.
  ! !

!PointrelRepository methodsFor: 'file reading and writing' stamp: 'pdf 6/30/2000 10:55'!
writeString: string toFile: file
  "use current position"
  file nextPutAll: string.! !


!PointrelRepository methodsFor: 'file handling' stamp: 'pdf 7/2/2000 20:19'!
closeFiles
        "only close once"
        triadFile isNil ifTrue: [^self].

        "ensure open if returning from snapshot and can't proceed"
        self ensureOpenFiles.

        "flush them all" 
        self flushFiles.

        "close them all"           
        triadFile close.   
        indexLastFile close.    
        indexPreviousFile close.    
        stringFile close. 
 
        "safety "
        triadFile := nil.  
        indexLastFile := nil.      
        indexPreviousFile := nil.      
        stringFile := nil.   
 ! !

!PointrelRepository methodsFor: 'file handling' stamp: 'pdf 6/29/2000 21:07'!
createFiles

        "open files, truncating them if they exist"
        triadFile := (FileStream newFileNamed: triadFileName) binary.     
        indexLastFile := (FileStream newFileNamed: indexLastFileName) binary.    
        indexPreviousFile := (FileStream newFileNamed: indexPreviousFileName) binary.
        stringFile :=  (FileStream newFileNamed: stringFileName) binary.
        self closeFiles.
        self openFiles: 0.
        self addCommonSharedConcepts.
        self closeFiles.
 ! !

!PointrelRepository methodsFor: 'file handling' stamp: 'pdf 7/2/2000 20:19'!
ensureOpenFiles

        "ensure open if returning from snapshot and can't proceed"
        triadFile ensureOpen.   
        indexLastFile ensureOpen.    
        indexPreviousFile ensureOpen.    
        stringFile ensureOpen. 
! !

!PointrelRepository methodsFor: 'file handling' stamp: 'pdf 6/30/2000 09:55'!
flushFiles

        "flush them all" 
        triadFile flush.    
        indexLastFile flush.    
        indexPreviousFile flush.   
        stringFile flush. 
! !

!PointrelRepository methodsFor: 'file handling' stamp: 'pdf 6/30/2000 10:47'!
openFiles
  self openFiles: 1.
        
! !

!PointrelRepository methodsFor: 'file handling' stamp: 'pdf 7/2/2000 01:08'!
openFiles: defineConstants

        | stream |
        "open files"
        "note that all but indexLastFile are modified by appending only"
        "only indexLastFile needs to be modified after it is written"

        stream := FileStream fileNamed: triadFileName.
        stream isNil ifTrue: [self halt: 'File probably already open'].
        triadFile := stream binary.     

        stream := FileStream fileNamed: indexLastFileName.
        stream isNil ifTrue: [self halt: 'File probably already open'].
        indexLastFile := stream binary.    

        stream := FileStream fileNamed: indexPreviousFileName.
        stream isNil ifTrue: [self halt: 'File probably already open'].
        indexPreviousFile := stream binary.

        stream := FileStream fileNamed: stringFileName.
        stringFile :=  stream binary.
        stream isNil ifTrue: [self halt: 'File probably already open'].

        defineConstants == 1 ifTrue: [self defineCommonSharedConceptConstants].
        
! !


!PointrelRepository methodsFor: 'caching' stamp: 'pdf 7/3/2000 14:41'!
addToCacheConcept: aString node: node.
  ^conceptCache at: aString put: node.! !

!PointrelRepository methodsFor: 'caching' stamp: 'pdf 7/3/2000 14:41'!
addToCacheName: aString node: node.
  ^nameCache at: aString put: node.! !

!PointrelRepository methodsFor: 'caching' stamp: 'pdf 7/3/2000 14:52'!
clearCaches
  conceptCache := Dictionary new.
  nameCache := Dictionary new.! !

!PointrelRepository methodsFor: 'caching' stamp: 'pdf 7/3/2000 14:38'!
conceptFromCache: aString
  ^conceptCache at: aString ifAbsent: [nil].! !

!PointrelRepository methodsFor: 'caching' stamp: 'pdf 7/3/2000 14:38'!
nameFromCache: aString
  ^nameCache at: aString ifAbsent: [nil].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PointrelRepository class
	instanceVariableNames: ''!

!PointrelRepository class methodsFor: 'testing' stamp: 'pdf 7/3/2000 19:49'!
zapAndTest

    "PointrelRepository zapAndTest."

    "result = 'ZAPNTEST'
    #result = raw_input('type 'ZAPNTEST' to proceeed with the test.
    #This will destroy your repository in: ' + os.getcwd() + '\\\n>')
    if result !!= 'ZAPNTEST': return"

    |r one two three four five|
    r := PointrelRepository new.
    r createFiles.
    r openFiles.
    Transcript show: '---- ZAPNTEST -----'; cr.
    one := r addTriadA: 0 B: 0 C: 0 string: 'One'.
    Transcript show: ('one = ', one printString); cr.
    two := r addTriadA: 0 B: 0 C: 0 string: 'Two'.
    three := r addTriadA: 0 B: 0 C: 0 string: 'Three'.
    four := r addTriadA: one B: two C: three string: 'One Two Three'.
    five := r addTriadA: one B: one C: four string: 'One One Four'.
    Transcript show: (r triadString: four); cr.
    Transcript show: (r triadString: one); cr.
    Transcript show: (r triadABCString: five) printString; cr.
    "#Transcript show: 'zero in a, b, or c'; cr.
    #Transcript show: r search(0, 0)
    #Transcript show: r search(0, 4)
    #Transcript show: r search(0, 8)
    #Transcript show: 'first test item in a, b, or c'; cr.
    #Transcript show: r search(one, 0)
    #Transcript show: r search(one, 4)
    #Transcript show: r search(one, 8)"
    Transcript show: 'lookup of basic named concepts'; cr.
    Transcript show: 'name for concept'; cr.
    Transcript show: (r triadForName: 'name for concept') printString; cr.
    Transcript show: (r triadForConcept: 'name for concept') printString; cr.
    Transcript show: 'defines symbol node'; cr.
    Transcript show: (r triadForName: 'defines symbol node') printString; cr.
    Transcript show: (r triadForConcept: 'defines symbol node') printString; cr.
    Transcript show: 'now add some names'; cr.
    Transcript show: (r triadForName: 'hello') printString; cr.
    Transcript show: (r triadForName: 'world') printString; cr.
    Transcript show: 'now add some concepts'; cr.
    Transcript show: (r triadForConcept: 'hello') printString; cr.
    Transcript show: (r triadForConcept: 'world') printString; cr.
    Transcript show: (r triadForConcept: 'Pointrel file system root node') printString; cr.
    Transcript show: (r triadForConcept: 'has subnode') printString; cr.
    Transcript show: (r triadForConcept: 'has name') printString; cr.
    Transcript show: 'closing'.
    r closeFiles.
! !


!PointrelRepository class methodsFor: 'instance creating' stamp: 'pdf 6/30/2000 10:49'!
new
^super new initialize! !


Model subclass: #PointrelRepositoryViewer
	instanceVariableNames: 'repository triadIndexViewed triadUseages triadUseagesDisplayed triadSelected visitedStack positionInStack triadFavorites triadFavoritesDisplayed triadFavoritesSelected '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pointrel-Core'!
!PointrelRepositoryViewer commentStamp: 'pdf 7/3/2000 20:00' prior: 0!
Pointrel(TM) Data Repository System
Copyright (c) 2000 Paul D. Fernhout
http://www.pointrel.com

===========================================

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

====================================================================

PointrelViewer consists of two list panels.
The left most one allows one to drill down into nodes. There is a back and forward option like a browser.
You can view all references to a node. You can also view references to the A, B, or C fields of that node.
You can also search for or add names and concepts.
You can jump to an arbitrary node.
To do an analysis of nodes, you can add a node to the favorites list to the left.

In the favorites list you can jump to a favorite node -- putting it in the left hand pane again.
Or you can delete a favorite.

Note: if you are browsing node 257, which is the 'name for concept' concept node,
you can see two 1040 entries in the left hand panel. That is OK.
This is because their is one entry for each time 1040 includes 257,
which is once for the B slot and once for the C slot.!


!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/2/2000 01:58'!
triadFavorites

^triadFavorites! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/2/2000 02:28'!
triadFavoritesDisplayed

^triadFavoritesDisplayed! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/2/2000 00:53'!
triadFavoritesDisplayed: aCollection

triadFavoritesDisplayed := aCollection.
self changed: #triadFavoritesDisplayed.! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/2/2000 00:53'!
triadFavoritesSelected

^triadFavoritesSelected! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/2/2000 00:53'!
triadFavoritesSelected: aTriadIndex

triadFavoritesSelected := aTriadIndex.
self changed: #triadFavoritesSelected.! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/1/2000 22:43'!
triadIndexViewed

^triadIndexViewed! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/2/2000 00:27'!
triadIndexViewed: aTriadIndex

triadIndexViewed := aTriadIndex.
self changed: #triadIndexViewed.
self computeTriadUseages.
self changed: #relabel.
self triadSelected: 0.
self changed: #contents.! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/2/2000 02:05'!
triadIndexViewedSimple: aTriadIndex

triadIndexViewed := aTriadIndex.
self computeTriadUseages.
! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/1/2000 22:41'!
triadSelected

^triadSelected! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/2/2000 00:53'!
triadSelected: aTriadIndex

triadSelected := aTriadIndex.
self changed: #triadSelected.! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/1/2000 22:41'!
triadUseages

^triadUseages! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/1/2000 22:49'!
triadUseages: aCollection

triadUseages := aCollection.
self changed: #triadUseages.! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/1/2000 23:22'!
triadUseagesDisplayed

^triadUseagesDisplayed! !

!PointrelRepositoryViewer methodsFor: 'accessing' stamp: 'pdf 7/1/2000 23:23'!
triadUseagesDisplayed: aCollection

triadUseagesDisplayed := aCollection.
self changed: #triadUseagesDisplayed.! !


!PointrelRepositoryViewer methodsFor: 'computing' stamp: 'pdf 7/2/2000 00:39'!
computeTriadUseages
	| newUseages useagesAsA useagesAsB useagesAsC newUseagesDisplayable collection |
	Cursor wait
		showWhile: 
			[newUseages := OrderedCollection new.
               newUseages add: triadIndexViewed.
			useagesAsA := repository search: triadIndexViewed offset: 0.
			useagesAsB := repository search: triadIndexViewed offset: 4.
			useagesAsC := repository search: triadIndexViewed offset: 8.
			newUseages addAll: useagesAsA.
			newUseages addAll: useagesAsB.
			newUseages addAll: useagesAsC.
			newUseagesDisplayable := newUseages
						collect: 
							[:each | 
							collection := repository triadABCString: each.
							each printString , ' ' , collection printString].
			self triadUseages: newUseages.
			self triadUseagesDisplayed: newUseagesDisplayable]! !

!PointrelRepositoryViewer methodsFor: 'computing' stamp: 'pdf 7/1/2000 23:36'!
labelString

^'PointrelViewer on Node: ', triadIndexViewed printString! !


!PointrelRepositoryViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/3/2000 19:36'!
initialize
        
         triadUseages := OrderedCollection new.
         triadUseagesDisplayed := OrderedCollection new.
         triadSelected := 0.

         triadFavorites := OrderedCollection new.
         triadFavoritesDisplayed := OrderedCollection new.
         triadFavoritesSelected := 0.

         visitedStack := OrderedCollection new.
         visitedStack add: 259. "start on definesSymbolNodeConcept".
         positionInStack := 1.

        "define some needed constant nodes"
        "none yet"! !

!PointrelRepositoryViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/2/2000 01:02'!
initializeRepository
        repository := PointrelRepository new.
        repository openFiles.
        
! !

!PointrelRepositoryViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/1/2000 23:32'!
windowIsClosing
  repository closeFiles.
  repository := nil.! !


!PointrelRepositoryViewer methodsFor: 'jumping' stamp: 'pdf 7/2/2000 00:36'!
findOrAddConcept

| result nameNode |
result := FillInTheBlank request: 'Enter a name to find or add:'.
(result isNil or: [result size < 1]) ifTrue: [^self].
nameNode := repository triadForConcept: result.
self triadIndexViewed: nameNode.
self pushLocation.! !

!PointrelRepositoryViewer methodsFor: 'jumping' stamp: 'pdf 7/2/2000 00:35'!
findOrAddName

| result nameNode |
result := FillInTheBlank request: 'Enter a name to find or add:'.
(result isNil or: [result size < 1]) ifTrue: [^self].
nameNode := repository triadForName: result.
self triadIndexViewed: nameNode.
self pushLocation.! !

!PointrelRepositoryViewer methodsFor: 'jumping' stamp: 'pdf 7/1/2000 23:57'!
forwardInStack

positionInStack >= visitedStack size ifTrue: [^self].
positionInStack := positionInStack + 1.
self triadIndexViewed: (visitedStack at: positionInStack).
! !

!PointrelRepositoryViewer methodsFor: 'jumping' stamp: 'pdf 7/1/2000 23:59'!
jumpBackwardInStack

self popLocation.! !

!PointrelRepositoryViewer methodsFor: 'jumping' stamp: 'pdf 7/2/2000 00:22'!
jumpForwardInStack

self forwardInStack.! !

!PointrelRepositoryViewer methodsFor: 'jumping' stamp: 'pdf 7/2/2000 02:46'!
jumpToUserEnteredIndex

| result target |
result := FillInTheBlank request: 'Enter a node to jump to:'.
(result isNil or: [result size < 1]) ifTrue: [^self].
target := result asNumber.
target < 0 ifTrue: [^self].
target >= repository triadCount 
   ifTrue: [^self halt: 'Value ', result, ' out of range. Max: ', (repository triadCount - 1) printString].
self triadIndexViewed: target.
self pushLocation.! !

!PointrelRepositoryViewer methodsFor: 'jumping' stamp: 'pdf 7/2/2000 00:11'!
popLocation

| oldLocation |
positionInStack <= 1 ifTrue: [^self].
positionInStack := positionInStack - 1.
oldLocation := visitedStack at: positionInStack.
self triadIndexViewed: oldLocation.! !

!PointrelRepositoryViewer methodsFor: 'jumping' stamp: 'pdf 7/1/2000 23:55'!
pushLocation

visitedStack := visitedStack copyFrom: 1 to: positionInStack.
visitedStack add: triadIndexViewed.
positionInStack := positionInStack + 1.! !


!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 02:30'!
addToFavorites

| collection newCollection |
self triadSelected > self triadUseages size ifTrue: [^self].
self triadSelected <= 0 ifTrue: [^self].
self triadFavorites add: (self triadUseages at: self triadSelected).
collection := repository triadABCString: self triadFavorites last.
"need new collection so list will update. Must not add ot orginal or update fails"
newCollection := self triadFavoritesDisplayed copy add: (self triadFavorites last printString , ' ' , collection printString); yourself.
"display list wants a new collection or it won't update"
self triadFavoritesDisplayed: newCollection.
self triadFavoritesSelected: self triadFavorites size.! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 02:32'!
deleteSelectedFavorite

| listCopy |
self triadFavoritesSelected > self triadFavorites size ifTrue: [^self].
self triadFavoritesSelected <= 0 ifTrue: [^self].
triadFavorites removeAt: self triadFavoritesSelected.
"need to work with a copy to get list to update properly"
listCopy := triadFavoritesDisplayed copy removeAt: self triadFavoritesSelected; yourself.
self triadFavoritesDisplayed: listCopy.! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 02:09'!
jumpToSelectedFavorite

self triadFavoritesSelected > self triadFavorites size ifTrue: [^self].
self triadFavoritesSelected <= 0 ifTrue: [^self].
self triadIndexViewed: (self triadFavorites at: self triadFavoritesSelected).
self pushLocation.! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 02:17'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then perform it on myself.  If not, send it to otherTarget, presumably the editPane from which the menu was invoked." 

	(#(viewCurrentSelectedTriadIndex viewCurrentSelectedTriadIndexA viewCurrentSelectedTriadIndexB viewCurrentSelectedTriadIndexC jumpToUserEnteredIndex jumpBackwardInStack jumpForwardInStack findOrAddName findOrAddConcept deleteSelectedFavorite jumpToSelectedFavorite addToFavorites) includes: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ super perform: selector orSendTo: otherTarget]! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/3/2000 20:14'!
triadFavoritesSelectedMenu: aMenu
	^ aMenu
		labels: #('jump to' 'delete from list' )
		lines: #(1)
		selections: #(jumpToSelectedFavorite deleteSelectedFavorite )! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 02:51'!
triadSelectedMenu: aMenu
	^ aMenu
		labels: #('view references' 'view A references' 'view B references' 'view C references' 'jump...' 'back' 'forward' 'find or add name...' 'find or add concept...' 'add to favorites')
		lines: #(1 4 5 7 9)
		selections: #(viewCurrentSelectedTriadIndex viewCurrentSelectedTriadIndexA viewCurrentSelectedTriadIndexB viewCurrentSelectedTriadIndexC jumpToUserEnteredIndex jumpBackwardInStack jumpForwardInStack findOrAddName findOrAddConcept addToFavorites)! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 00:10'!
viewCurrentSelectedTriadIndex

self triadSelected > self triadUseages size ifTrue: [^self].
self triadSelected <= 0 ifTrue: [^self].
self triadIndexViewed: (self triadUseages at: self triadSelected).
self pushLocation.! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 00:17'!
viewCurrentSelectedTriadIndexA

self triadSelected > self triadUseages size ifTrue: [^self].
self triadSelected <= 0 ifTrue: [^self].
self triadIndexViewed: (repository triadA: (self triadUseages at: (self triadSelected))).
self pushLocation..! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 00:17'!
viewCurrentSelectedTriadIndexB

self triadSelected > self triadUseages size ifTrue: [^self].
self triadSelected <= 0 ifTrue: [^self].
self triadIndexViewed: (repository triadB: (self triadUseages at: (self triadSelected))).
self pushLocation.! !

!PointrelRepositoryViewer methodsFor: 'menu handling' stamp: 'pdf 7/2/2000 00:18'!
viewCurrentSelectedTriadIndexC

self triadSelected > self triadUseages size ifTrue: [^self].
self triadSelected <= 0 ifTrue: [^self].
self triadIndexViewed: (repository triadC: (self triadUseages at: (self triadSelected))).
self pushLocation.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PointrelRepositoryViewer class
	instanceVariableNames: ''!

!PointrelRepositoryViewer class methodsFor: 'instance creating' stamp: 'pdf 7/1/2000 22:33'!
new
^super new initialize! !

!PointrelRepositoryViewer class methodsFor: 'instance creating' stamp: 'pdf 7/3/2000 21:36'!
open
	"Open a view of an instance of me."
	"PointrelRepositoryViewer open"

    "You need to have first created the repository files using the test method in: PointrelRepository zapAndTest."
    "Then you may want to add a few files to a file system by running this a few times: PointrelFileSystem test."
    "Note that because of file locking you can't have the viewer open and use this code to modify the repository at the same time."

     "In case of trouble opening where get file open halt or 'Message Not Understood 'binary', try again, if fails save image, exit, and reopen it. "
     "This usually comes about from a failure in the window open code leaving open repositories lying around attached to zombie windows."
	|  aPointrelRepositoryViewer topView triadUseagesView triadFavoritesView |
	aPointrelRepositoryViewer _ self new.
	topView _ StandardSystemView new.
	topView
		model: aPointrelRepositoryViewer;
		label: 'PointrelViewer';
		minimumSize: 200@200.
	topView borderWidth: 1.

     aPointrelRepositoryViewer initializeRepository.
     aPointrelRepositoryViewer triadIndexViewedSimple: 259. "start on definesSymbolNodeConcept"

 	triadUseagesView _ PluggableListView on: aPointrelRepositoryViewer
		list: #triadUseagesDisplayed
		selected: #triadSelected
		changeSelected: #triadSelected:
		menu: #triadSelectedMenu:.
	"triadUseagesView autoDeselect: false."
	"triadUseagesView window: (0@0 extent: topView width @ (topView height / 2))."
	topView addSubView: triadUseagesView.

	triadFavoritesView _ PluggableListView on: aPointrelRepositoryViewer
		list: #triadFavoritesDisplayed
		selected: #triadFavoritesSelected
		changeSelected: #triadFavoritesSelected:
		menu: #triadFavoritesSelectedMenu:.
	"triadFavoritesView autoDeselect: false."
	"triadFavoritesView window: (0 @ (topView height / 2) extent: topView width @ topView height)."
	topView addSubView: triadFavoritesView toRightOf: triadUseagesView.

	topView controller open.
! !


Object subclass: #PointrelTableManager
	instanceVariableNames: 'repository '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pointrel-Core'!
!PointrelTableManager commentStamp: 'pdf 7/1/2000 20:17' prior: 0!
Pointrel(TM) Data Repository System
Copyright (c) 2000 Paul D. Fernhout
http://www.pointrel.com

===========================================

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

====================================================================
Not finished.
This is going to support storing and retrieving arbitrary tables of data with named columns and indexed rows.!


!PointrelTableManager methodsFor: 'initializing and releasing' stamp: 'pdf 7/1/2000 19:53'!
initialize
        repository := PointrelRepository new.
        repository openFiles.
        
        "define some needed constant nodes"
        "none yet"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PointrelTableManager class
	instanceVariableNames: ''!

!PointrelTableManager class methodsFor: 'instance creating' stamp: 'pdf 7/1/2000 18:39'!
new
^super new initialize! !


Model subclass: #PointrelTreeArchiveViewer
	instanceVariableNames: 'archiver treeDisplayed treeNodes treeSelected root rootNodeVersion contents topView treeView contentsView parentDictionary superRoot '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pointrel-Core'!
!PointrelTreeArchiveViewer commentStamp: 'pdf 7/4/2000 23:42' prior: 0!
Copyright (c) 2000 Paul D. Fernhout
http://www.pointrel.com

Views a tree archive from a default root node. 
Supports making multiple versions of nodes and freezing them.
Hierarchy keeps track of current versions of subnodes.!


!PointrelTreeArchiveViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/4/2000 23:31'!
createRootAndSampleData

| a1 a2 rc1 rv1 c1 c2 c3 v1 v2 v3  |
superRoot := archiver repository concept: 'default tree archive'.
rootNodeVersion := archiver repository searchForLatestCA: superRoot B: (archiver repository concept: 'has root node version').
(rootNodeVersion isNil or: [rootNodeVersion < 1]) 
  ifFalse: [root := archiver namedNodeForNodeVersion: rootNodeVersion. ^self].

root := archiver createNamedNode: 'my test root' asSubnodeOf: nil.
a1 := archiver createNamedNode: 'a1' asSubnodeOf: root.
a2 := archiver createNamedNode: 'a2' asSubnodeOf: root.

rc1 := archiver createContentsVersion: self timestampString contents: 'root some contents 1' forNamedNode: root.
rv1 := archiver createNodeVersion: self timestampString forNamedNode: root currentContentsVersion: rc1.
rootNodeVersion := rv1.
archiver repository addTriadA: superRoot B: (archiver repository concept: 'has root node version') C: rootNodeVersion.

c1 := archiver createContentsVersion: self timestampString contents: 'some contents 1' forNamedNode: a1.
c2 := archiver createContentsVersion: self timestampString contents: 'some contents 2' forNamedNode: a1.
c3 := archiver createContentsVersion: self timestampString contents: 'some contents 3' forNamedNode: a1.
v1 := archiver createNodeVersion: self timestampString forNamedNode: a1 currentContentsVersion: c1.
v2 := archiver createNodeVersion: self timestampString forNamedNode: a1 currentContentsVersion: c2.
v3 := archiver createNodeVersion: self timestampString forNamedNode: a1 copyFrom: v1.

archiver addSubnodeVersion: v3 forNodeVersion: rv1.

! !

!PointrelTreeArchiveViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/3/2000 22:07'!
initialize
  archiver := nil.
  treeSelected := 0.
  treeDisplayed := OrderedCollection new.
  treeNodes := OrderedCollection new.
  contents := String new.! !

!PointrelTreeArchiveViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/4/2000 23:32'!
initializeArchiver
  archiver := PointrelTreeArchiver new.
  superRoot isNil ifTrue: [self createRootAndSampleData].
  self updateTreeView.! !

!PointrelTreeArchiveViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/4/2000 23:36'!
open
    	"PointrelTreeArchiveViewer open"
	self open: nil.
! !

!PointrelTreeArchiveViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/4/2000 23:35'!
open: aSuperRoot
    	"PointrelTreeArchiveViewer open"
	|  aViewer |
	aViewer _ self.
	topView _ StandardSystemView new.
	topView
		model: aViewer;
		label: 'PointrelTreeArchiveViewer';
		minimumSize: 200@200.
	topView borderWidth: 1.

     aViewer superRoot: aSuperRoot.
     aViewer initializeArchiver.

 	treeView _ PluggableListView on: aViewer
		list: #treeDisplayed
		selected: #treeSelected
		changeSelected: #treeSelected:
		menu: #treeSelectedMenu:.
	topView addSubView: treeView.

	contentsView _ PluggableTextView on: aViewer
	    text: #contents accept: #contents:notifying:
         readSelection: nil menu: #contentsMenu:.
	topView addSubView: contentsView toRightOf: treeView.

	topView controller open.
! !

!PointrelTreeArchiveViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/3/2000 23:58'!
setRootNodeVersion: nodeVersion

| superRoot |
superRoot := archiver repository concept: 'default tree archive'.
rootNodeVersion := nodeVersion.
archiver repository addTriadA: superRoot B: (archiver repository concept: 'has root node version') C: rootNodeVersion.

! !

!PointrelTreeArchiveViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/4/2000 23:35'!
superRoot: aSuperRoot
  superRoot := aSuperRoot.! !

!PointrelTreeArchiveViewer methodsFor: 'initializing and releasing' stamp: 'pdf 7/3/2000 21:43'!
windowIsClosing
  archiver repository closeFiles.
  archiver := nil.! !


!PointrelTreeArchiveViewer methodsFor: 'contents view handling' stamp: 'pdf 7/3/2000 22:07'!
contents

^contents! !

!PointrelTreeArchiveViewer methodsFor: 'contents view handling' stamp: 'pdf 7/3/2000 22:08'!
contents: aString

contents := aString.
self changed: #contents.! !

!PointrelTreeArchiveViewer methodsFor: 'contents view handling' stamp: 'pdf 7/3/2000 22:50'!
contents: input notifying: aController
  Transcript show: 'changed'; cr.
  self contents: input asString.! !

!PointrelTreeArchiveViewer methodsFor: 'contents view handling' stamp: 'pdf 7/4/2000 08:16'!
contentsAccept

    | newVersionString nodeVersion newContentsVersion namedNode |
    (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^self].
    self isSelectionFrozen ifTrue: [PopUpMenu notify: 'The node version is frozen. You must make a new version first.'. ^self].
    nodeVersion := treeNodes at: treeSelected.
    namedNode := archiver namedNodeForNodeVersion: nodeVersion.
    newVersionString := contentsView displayContents asString.
    newContentsVersion :=  archiver createContentsVersion: self timestampString contents: newVersionString forNamedNode: namedNode.
   archiver setContentsVersion: newContentsVersion forNodeVersion: nodeVersion.

! !

!PointrelTreeArchiveViewer methodsFor: 'contents view handling' stamp: 'pdf 7/3/2000 22:53'!
contentsCancel

self contents: self contents.! !

!PointrelTreeArchiveViewer methodsFor: 'contents view handling' stamp: 'pdf 7/4/2000 08:20'!
contentsMenu: aMenu

	^ aMenu
		labels: #('accept' 'cancel' 'versions')
		lines: #(12)
		selections: #(contentsAccept contentsCancel contentsVersions)! !

!PointrelTreeArchiveViewer methodsFor: 'contents view handling' stamp: 'pdf 7/4/2000 23:25'!
contentsVersions

    | nodeVersion namedNode contentsVersions choices choice contentsString |
    (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^self].
     Transcript cr; show: '==== versions ===='; cr.
    nodeVersion := treeNodes at: treeSelected.
    namedNode := archiver namedNodeForNodeVersion: nodeVersion.
    choices := OrderedCollection new.
    contentsVersions := archiver contentsVersionsForNamedNode: namedNode.
    contentsVersions do: [:each |
        Transcript show: (archiver versionTagForContentsVersion: each); cr.
        "Transcript show: (archiver contentsForContentsVersion: each); cr."
        choice := Array with: (archiver versionTagForContentsVersion: each) with: each.
        choices add: choice.
        ].
   
   choice := (SelectionMenu fromArray: choices) startUp.
   Transcript show: choice printString; cr.
    choice isNil ifTrue: [^self].
    self isSelectionFrozen ifTrue: [PopUpMenu notify: 'The node version is frozen. You must make a new version first.'. ^self].
    contentsString := archiver contentsForContentsVersion: choice.
    archiver setContentsVersion: choice forNodeVersion: nodeVersion.
    self contents: contentsString.
    
   "archiver setContentsVersion: newContentsVersion forNodeVersion: nodeVersion."



! !


!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 00:57'!
changeNodeVersion: newNodeVersion

    | nodeVersion parentNodeVersion |
    (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^self].
  
    nodeVersion := treeNodes at: treeSelected.
   "assuming strict hierarchy for now"
   parentNodeVersion := archiver nodeVersionParentForNodeVersion: nodeVersion.
   parentNodeVersion isNil 
        ifTrue: [self setRootNodeVersion: newNodeVersion]
        ifFalse: [
            archiver repository beginTransaction.
            archiver removeSubnodeVersion: nodeVersion forNodeVersion: parentNodeVersion.
            archiver addSubnodeVersion: newNodeVersion forNodeVersion: parentNodeVersion.
            archiver repository endTransaction.].
   self updateTreeView.
    

  ! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:20'!
freezeVersion

    | nodeVersion versionTagString |
    (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^self].
    nodeVersion := treeNodes at: treeSelected.
    self isSelectionFrozen ifTrue: [PopUpMenu notify: 'The node version is already frozen.'. ^self].
    versionTagString := FillInTheBlank request: 'Enter a tag for the frozen version of this node version and all subnode versions:'.
    (versionTagString isNil or: [versionTagString size < 1]) ifTrue: [^self].
    archiver freezeRecursivelyNodeVersion: nodeVersion versionTag: versionTagString.
    self updateTreeView.

! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 22:57'!
importTextFiles
  | nodeVersion directoryName |
  (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^self].

    self isSelectionFrozen ifTrue: [PopUpMenu notify: 'The parent is frozen. You must make a new version of the parent first.'. ^self].

    nodeVersion := treeNodes at: treeSelected.
   "directoryName := 'Y:\Temp\'."
    "directoryName := 'C:\'."
    directoryName := FillInTheBlank request: 'Enter a directory path to recursively read *.txt files from ending with "\" as in "C:\temp\"' initialAnswer: 'C:\temp\'.
    (directoryName isNil or: [directoryName size < 1]) ifTrue: [^self].
    self importTextFiles: directoryName nodeVersion: nodeVersion.

   self updateTreeView.
    

  ! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 23:11'!
importTextFiles: directoryName nodeVersion: nodeVersion 
	| namedNode newNamedNode newContentsVersion newNodeVersion dir fileStream fileContents |
	namedNode := archiver namedNodeForNodeVersion: nodeVersion.
	dir := FileDirectory forFileName: directoryName.
     Transcript show: 'importing from ', directoryName; cr.
	(dir fileNamesMatching: '*.txt')
		do: 
			[:shortName | 
              "if named node exisits, do not recreate it"
              newNamedNode := archiver namedSubNode: shortName forNamedNode: namedNode.
              newNamedNode isNil 
                  ifTrue: [
			        newNamedNode := archiver createNamedNode: shortName asSubnodeOf: namedNode.
                      ]
                  ifFalse: [
                     newNodeVersion := archiver findSubnodeVersionWithName: shortName forNodeVersion: nodeVersion.
                     newNodeVersion notNil ifTrue: [
                         archiver removeSubnodeVersion: newNodeVersion forNodeVersion: nodeVersion]].
			fileStream := dir oldFileNamed: shortName.
			fileContents := fileStream contentsOfEntireFile.
			fileStream close.
			newContentsVersion := archiver
						createContentsVersion: self timestampString
						contents: fileContents
						forNamedNode: newNamedNode.
			newNodeVersion := archiver
						createNodeVersion: self timestampString
						forNamedNode: newNamedNode
						currentContentsVersion: newContentsVersion.
			archiver addSubnodeVersion: newNodeVersion forNodeVersion: nodeVersion].
	(dir directoryNames)
		do: 
			[:shortName | 
              "if named node exisits, do not recreate it"
              newNamedNode := archiver namedSubNode: shortName forNamedNode: namedNode.
              newNamedNode isNil 
                  ifTrue: [
			        newNamedNode := archiver createNamedNode: shortName asSubnodeOf: namedNode.
                       ]
                  ifFalse: [
                     newNodeVersion := archiver findSubnodeVersionWithName: shortName forNodeVersion: nodeVersion.
                     newNodeVersion notNil ifTrue: [
                         archiver removeSubnodeVersion: newNodeVersion forNodeVersion: nodeVersion]].
			newContentsVersion := archiver
						createContentsVersion: self timestampString
						contents: 'DIRECTORY'
						forNamedNode: newNamedNode.
			newNodeVersion := archiver
						createNodeVersion: self timestampString
						forNamedNode: newNamedNode
						currentContentsVersion: newContentsVersion.
			archiver addSubnodeVersion: newNodeVersion forNodeVersion: nodeVersion.
              self importTextFiles: ((dir fullNameFor: shortName), '\') nodeVersion: newNodeVersion.]
! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:15'!
namedNodeVersions
	| nodeVersion namedNode nodeVersions name versionTagString choices choice |
	(treeSelected < 1 or: [treeSelected > treeNodes size])
		ifTrue: [^ self].
	nodeVersion := treeNodes at: treeSelected.
	namedNode := archiver namedNodeForNodeVersion: nodeVersion.
	nodeVersions := archiver nodeVersionsForNamedNode: namedNode.
	name := archiver nameForNamedNode: namedNode.
    choices := OrderedCollection new.
	Transcript show: ' === versions for ' , name, ' ====='; cr.
	nodeVersions do: 
		[:each | 
		versionTagString := archiver versionTagStringForNodeVersion: each.
		Transcript show: versionTagString; cr.
        choice := Array with: versionTagString with: each.
        choices add: choice.
        ].

   choice := (SelectionMenu fromArray: choices) startUp.
   Transcript show: choice printString; cr.
    choice isNil ifTrue: [^self].
    self isSelectionParentFrozen ifTrue: [PopUpMenu notify: 'The parent is frozen. You must make a new version of the parent first.'. ^self].
   self changeNodeVersion: choice.
! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:47'!
newNamedNode
  | nodeVersion namedNode name newNameNode newContentsVersion newNodeVersion |
  (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^self].

    self isSelectionFrozen ifTrue: [PopUpMenu notify: 'The parent is frozen. You must make a new version of the parent first.'. ^self].

    nodeVersion := treeNodes at: treeSelected.
    namedNode := archiver namedNodeForNodeVersion: nodeVersion.
    name := FillInTheBlank request: 'Enter a name for the new node: (leave empty to cancel):'.
    (name isNil or: [name size < 1]) ifTrue: [^self].
    newNameNode := archiver createNamedNode: name asSubnodeOf: namedNode.
    newContentsVersion := archiver createContentsVersion: self timestampString contents: 'sample contents ', newNameNode printString forNamedNode: newNameNode.
    newNodeVersion := archiver createNodeVersion: self timestampString forNamedNode: newNameNode currentContentsVersion: newContentsVersion.
   archiver addSubnodeVersion: newNodeVersion forNodeVersion: nodeVersion.
   self updateTreeView.
    

  ! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:14'!
newNodeVersion

    | nodeVersion namedNode newNodeVersion parentNodeVersion |
    (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^self].
 
    self isSelectionParentFrozen ifTrue: [PopUpMenu notify: 'The parent is frozen. You must make a new version of the parent first.'. ^self].
    nodeVersion := treeNodes at: treeSelected.
    namedNode := archiver namedNodeForNodeVersion: nodeVersion.
    newNodeVersion := archiver createNodeVersion: self timestampString forNamedNode: namedNode copyFrom: nodeVersion.
   "assuming strict hierarchy for now doesn't work because can have two nodes which both use same version"
   parentNodeVersion := self nodeVersionParentForNodeVersion: nodeVersion.
   parentNodeVersion isNil 
        ifTrue: [self setRootNodeVersion: newNodeVersion]
        ifFalse: [
            archiver repository beginTransaction.
            archiver removeSubnodeVersion: nodeVersion forNodeVersion: parentNodeVersion.
            archiver addSubnodeVersion: newNodeVersion forNodeVersion: parentNodeVersion.
            archiver repository endTransaction.].
   self updateTreeView.
    

  ! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:37'!
newNodeVersionForAllSubnodes

  PopUpMenu notify: 'newNodeVersionForAllSubnodes is not finished'.
    

  ! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:26'!
nodeVersionParentForNodeVersion: nodeVersion
  ^parentDictionary at: nodeVersion ifAbsent: [nil].

  
  ! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:37'!
possibleSubnodes

   PopUpMenu notify: 'possibleSubnodes is not finished'.

! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/3/2000 21:47'!
treeDisplayed

^treeDisplayed! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/3/2000 21:46'!
treeSelected

^treeSelected! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/3/2000 22:14'!
treeSelected: anIndex 
	| nodeVersion newContents |
	treeSelected := anIndex.
	self changed: #treeSelected.
	(treeSelected < 1 or: [treeSelected > treeNodes size])
		ifTrue: [self contents: 'NO SELECTION']
		ifFalse: 
			[nodeVersion := treeNodes at: treeSelected.
			newContents := archiver currentContentsForNodeVersion: nodeVersion.
			self contents: newContents.
              "Transcript show: nodeVersion printString, newContents; cr."]! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:44'!
treeSelectedMenu: aMenu

	^ aMenu
		labels: #('new named subnode' 'versions'   'new version' 'new version & subnodes' 'possible subnodes' 'freeze node & subnodes' 'import text files')
		lines: #(1 4 5 6)
		selections: #(newNamedNode namedNodeVersions newNodeVersion newNodeVersionForAllSubnodes  possibleSubnodes freezeVersion importTextFiles)! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 22:55'!
updateTreeView
	"put what is needed for nodes in various vars"
	Cursor wait
		showWhile: 
			[parentDictionary := Dictionary new.
			treeDisplayed := OrderedCollection new.
			treeNodes := OrderedCollection new.
			self updateTreeView: rootNodeVersion level: 0.
			self changed: #treeDisplayed]! !

!PointrelTreeArchiveViewer methodsFor: 'tree view handling' stamp: 'pdf 7/4/2000 08:30'!
updateTreeView: nodeVersion level: level
    | indent name versionTagString aString currentSubnodeVersions currentSubnodeVersionsSorted |
    treeNodes add: nodeVersion.
    indent := archiver indentForLevel: level.
    name := archiver nameForNamedNode: (archiver namedNodeForNodeVersion: nodeVersion).
    versionTagString := archiver versionTagStringForNodeVersion: nodeVersion.
    aString := indent , name, ' ', versionTagString.
    treeDisplayed add: aString.
    currentSubnodeVersions := archiver currentSubnodeVersionsForNodeVersion: nodeVersion.
    currentSubnodeVersionsSorted := currentSubnodeVersions asSortedCollection: [:a :b | (archiver nameForNamedNode: (archiver namedNodeForNodeVersion: a) ) < (archiver nameForNamedNode: (archiver namedNodeForNodeVersion: b))].
    currentSubnodeVersionsSorted do: [:each | 
                  self updateTreeView: each level: level + 1. 
                  "kludge to backtrack versions -- would fail if version can be in two places in tree"
                  parentDictionary at: each put: nodeVersion.].

  
  ! !


!PointrelTreeArchiveViewer methodsFor: 'timestamping' stamp: 'pdf 7/3/2000 23:20'!
timestampString

^Date dateAndTimeNow printString! !


!PointrelTreeArchiveViewer methodsFor: 'checking' stamp: 'pdf 7/4/2000 08:22'!
isSelectionFrozen

    | nodeVersion |
    (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^false].
    nodeVersion := treeNodes at: treeSelected.
    ^archiver isFrozen: nodeVersion
! !

!PointrelTreeArchiveViewer methodsFor: 'checking' stamp: 'pdf 7/4/2000 08:22'!
isSelectionParentFrozen

    | nodeVersion parentNodeVersion |
    (treeSelected < 1 or: [treeSelected > treeNodes size]) ifTrue: [^false].
    nodeVersion := treeNodes at: treeSelected.
    parentNodeVersion := self nodeVersionParentForNodeVersion: nodeVersion.
     (parentNodeVersion isNil or: [parentNodeVersion < 1]) ifTrue: [^false]. 
    ^archiver isFrozen: parentNodeVersion. 
! !


!PointrelTreeArchiveViewer methodsFor: 'performing' stamp: 'pdf 7/4/2000 08:44'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then perform it on myself.  If not, send it to otherTarget, presumably the editPane from which the menu was invoked." 

	(#(newNamedNode contentsAccept contentsCancel contentsVersions  newNodeVersion namedNodeVersions freezeVersion possibleSubnodes newNodeVersionForAllSubnodes importTextFiles) includes: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ super perform: selector orSendTo: otherTarget]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PointrelTreeArchiveViewer class
	instanceVariableNames: ''!

!PointrelTreeArchiveViewer class methodsFor: 'instance creating' stamp: 'pdf 7/3/2000 21:36'!
new
^super new initialize! !

!PointrelTreeArchiveViewer class methodsFor: 'instance creating' stamp: 'pdf 7/4/2000 23:37'!
open
     "Open a view of an instance of me on the default directory."
	"PointrelTreeArchiveViewer open"
	^self open: nil.! !

!PointrelTreeArchiveViewer class methodsFor: 'instance creating' stamp: 'pdf 7/4/2000 23:37'!
open: aSuperRoot
	"Open a view of an instance of me on the super root selected (nil = default)."
	"PointrelTreeArchiveViewer open"

    "You need to have first created the repository files using the test method in: PointrelRepository zapAndTest."
    "Note that because of file locking you can't have the viewer open and use this code to modify the repository at the same time."

     "In case of trouble opening where get file open halt or 'Message Not Understood 'binary', try again, if fails save image, exit, and reopen it. "
     "This usually comes about from a failure in the window open code leaving open repositories lying around attached to zombie windows."
	|  aViewer  |
	aViewer _ self new.
    aViewer open: aSuperRoot.! !


Object subclass: #PointrelTreeArchiver
	instanceVariableNames: 'repository '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pointrel-Core'!
!PointrelTreeArchiver commentStamp: 'pdf 7/4/2000 23:41' prior: 0!
Copyright (c) 2000 Paul D. Fernhout
http://www.pointrel.com

PointrelTreeArchiver

maintains multiple versions of things.

This is the recursive structure maintained. 
There is one top level named node called "tree archive root".
This node points to other nodes which contain versions of archive information.
Any user of this archive to load a sensible subset of the archive 
then will have one "node version" of "tree archive root" (ot lower in the tree).
This node version will point to other specific node versions
which defines a subset of the archive.

In this definition, except for the first node, each line starts with the name of a property of the object type above it.
The first node
Three dots such as '...' denotes that the previous property line above it can be repeated multiple times.
'had property -> type' denotes the expected type of the property.
The subsequent indented lines define the properties of this type if it is new.
Things in double quotes are comments.

    named node
        has name -> string
        has node version list -> node version list
            has node version -> node version
                has version tag -> string
                has current contents version -> contents version
                "the following node version should be from a subnode's version list"
                has current subnode version -> node version
                ...
            ...
        has contents version list -> contents version list
            has contents version -> contents version
                has contents -> string
                has version tag -> string
            ...
        has subnode list -> subnode list
            has named node -> named node
            ...
        "The following field is only appropriate if there is only one shared current state by all archive users"
        has loaded version -> node version

Or, decomposed into pseudo-objects:

    node version list
        has node version -> node version
        ...

    node version
        has version tag -> string
        has current contents version -> contents version
        "the following node version should be from a subnode's version list"
        has current subnode version -> node version
        ...

    contents version list
        has contents version -> contents version
        ...

    contents version
        has contents -> string
        has version tag -> string

    subnode list
        has named node -> named node
        ...

    named node
        has name -> string
        has node version list -> node version list
        has contents version list -> contents version list
        has subnode list -> subnode list
        "The following field is only appropriate if there is only one shared current state by all archive users"
        has loaded version -> node version

Example Pointrel operations:
  These are defined in Pointrel query syntax where:
  '?' returns the latest match for a triad.
  '??' returns all matches for a triad.
  Lists of words are parsed to make concepts based on previously understood phrasing.
  Words in single quotes like 'my own filename.txt' are parsed as strings.
  Queries can return a single result or multiple.
  Any query with a '??' in it somewhere returns a collections. 
  Any query with a variable in it that is a collection returns a collection.
  Alternatively, if a query has all question marks it returns a single value.
  A question mark returns the latest matching triad or value, even if more than one match might exist.
  Parentheses allow nesting of queries.
  Curly brackets '{}' instead of parentheses '()' returns the matching triad instead of the positional (A, B, C) field in the matching triad.
  Results can be assigned to variables.
  The word 'has' can be used as syntactic sugar to denote properties and it is assumed the structure above is defined using 'has' in various places.
  Note that naming the result of a '?' or '??' query variable is optional.

  To get all versions of a current subnode version,
      SubnodeVersion := current subnode version
      SubnodeVersions := ((?Subnode has node version SubnodeVersion) has node version ??SubnodeVersions)
  The second line means roughly in English: 
      "get the triad who links to the SubNodeVersion via 'has node version', 
      and then from that triad, get all the triads linked to to by 'has node version'."
  Equivalent query without naming intermediate query results:
      SubnodeVersion := current subnode version
      SubnodeVersions := ((? has node version SubnodeVersion) has node version ??)
  Also equivalent:
      SubnodeVersion := current subnode version
      Subnode := (?Subnode has node version SubnodeVersion)
      SubnodeVersions := (SubNode has node version ??)
  Also equivalent if only operating in Pointrel Query Syntax:
      queryAllSubnodeVersions: SubnodeVersion
          | Subnode SubnodeVersions |
          ?Subnode has node version SubnodeVersion
          SubNode has node version ??SubnodeVersions
          ^SubnodeVersions

  To get all previously added named subnodes that might have versions that could be linked as current subnode versions to a current subnode version:
      SubnodeVersion := current subnode version
      NamedNode := (?NamedNode has node version list (?SubNodeList has node version SubnodeVersion))
      Subnodes := ((NamedNode has subnode list ?SubNodeList) has named node *Subnodes)
  The name for one of these retrieved Subnodes is:
      Subnode := named node
      Name := (Subnode has name ?Name)
  The node versions for one of these retrieved Subnodes are:
      Subnode := named node
      NodeVersions := ((Subnode has node version list ?NodeVersionList) has node version ??NodeVersions)
   The version tags for all these NodeVersions would be (hypothetically):
       NodeVersions := ?? node version
       VersionTags := (NodeVersions has version tag ?VersionTags)
       
   Note this query syntax system is not implimented in the current release.


!


!PointrelTreeArchiver methodsFor: 'contents version accessing' stamp: 'pdf 7/3/2000 15:38'!
contentsForContentsVersion: contentsVersion

| triad |
triad := repository searchForLatestCA: contentsVersion B: (repository concept: 'has contents').
^repository triadString: triad.! !

!PointrelTreeArchiver methodsFor: 'contents version accessing' stamp: 'pdf 7/3/2000 15:39'!
versionTagForContentsVersion: contentsVersion

| triad |
triad := repository searchForLatestCA: contentsVersion B: (repository concept: 'has version tag').
^repository triadString: triad.! !


!PointrelTreeArchiver methodsFor: 'contents version creating' stamp: 'pdf 7/3/2000 18:14'!
createContentsVersion: versionTag contents: aString forNamedNode: namedNode

|  contentsVersionNode contentsStringNode versionTagStringNode namedNodeVersionList namedNodeContentsVersionList |
repository beginTransaction.

contentsVersionNode := repository addTriadAbstract.

contentsStringNode := repository addTriadString: aString.
repository addTriadA: contentsVersionNode B: (repository concept: 'has contents') C: contentsStringNode.

versionTagStringNode := repository addTriadString: versionTag.
repository addTriadA: contentsVersionNode B: (repository concept: 'has version tag') C: versionTagStringNode.

namedNodeContentsVersionList := self contentsVersionListForNamedNode: namedNode.
repository addTriadA: namedNodeContentsVersionList B: (repository concept: 'has contents version') C: contentsVersionNode.

repository endTransaction.

^contentsVersionNode
! !


!PointrelTreeArchiver methodsFor: 'initializing and releasing' stamp: 'pdf 7/3/2000 15:36'!
initialize
        repository := PointrelRepository new.
        repository openFiles.
! !


!PointrelTreeArchiver methodsFor: 'list accessing' stamp: 'pdf 7/3/2000 15:42'!
contentsVersionsInContentsVersionList: contentsVersionList

^repository searchForAllCsA: contentsVersionList B: (repository concept: 'has contents version').! !

!PointrelTreeArchiver methodsFor: 'list accessing' stamp: 'pdf 7/3/2000 15:41'!
namedNodeForNodeVersionList: nodeVersionList

^repository searchForLatestAB: (repository concept: 'has node version list') C: nodeVersionList.! !

!PointrelTreeArchiver methodsFor: 'list accessing' stamp: 'pdf 7/3/2000 20:32'!
namedNodesInSubnodeList: subnodeList

| triads |
"return a list of values, having made sure triads were not previously removed"
"^repository searchForAllCsA: subnodeList B: (repository concept: 'has named node')."
triads := repository searchForAllCsA: subnodeList B: (repository concept: 'has named node').
^triads select: [:each | (repository checkIfMarkedRemoved: each) not].

! !

!PointrelTreeArchiver methodsFor: 'list accessing' stamp: 'pdf 7/3/2000 15:43'!
nodeVersionsInNodeVersionList: nodeVersionList

^repository searchForAllCsA: nodeVersionList B: (repository concept: 'has node version').! !


!PointrelTreeArchiver methodsFor: 'named node accessing' stamp: 'pdf 7/3/2000 15:54'!
contentsVersionListForNamedNode: namedNode

^repository searchForLatestCA: namedNode B: (repository concept: 'has contents version list').! !

!PointrelTreeArchiver methodsFor: 'named node accessing' stamp: 'pdf 7/3/2000 15:34'!
contentsVersionsForNamedNode: namedNode

^self contentsVersionsInContentsVersionList: (self contentsVersionListForNamedNode: namedNode).! !

!PointrelTreeArchiver methodsFor: 'named node accessing' stamp: 'pdf 7/3/2000 15:50'!
nameForNamedNode: namedNode

| triad |
triad := repository searchForLatestCA: namedNode B: (repository concept: 'has name').
^repository triadString: triad.! !

!PointrelTreeArchiver methodsFor: 'named node accessing' stamp: 'pdf 7/4/2000 23:01'!
namedSubNode: name forNamedNode: namedNode
  (self subnodesForNamedNode: namedNode) do: [:each | name = (self nameForNamedNode: each) ifTrue: [^each]].
  ^nil! !

!PointrelTreeArchiver methodsFor: 'named node accessing' stamp: 'pdf 7/3/2000 15:54'!
nodeVersionListForNamedNode: namedNode

^repository searchForLatestCA: namedNode B: (repository concept: 'has node version list').! !

!PointrelTreeArchiver methodsFor: 'named node accessing' stamp: 'pdf 7/3/2000 15:35'!
nodeVersionsForNamedNode: namedNode

^self nodeVersionsInNodeVersionList: (self nodeVersionListForNamedNode: namedNode).! !

!PointrelTreeArchiver methodsFor: 'named node accessing' stamp: 'pdf 7/3/2000 15:54'!
subnodeListForNamedNode: namedNode

^repository searchForLatestCA: namedNode B: (repository concept: 'has subnode list').! !

!PointrelTreeArchiver methodsFor: 'named node accessing' stamp: 'pdf 7/3/2000 16:23'!
subnodesForNamedNode: namedNode

^self namedNodesInSubnodeList: (self subnodeListForNamedNode: namedNode).! !


!PointrelTreeArchiver methodsFor: 'named node creating' stamp: 'pdf 7/3/2000 22:25'!
createNamedNode: name asSubnodeOf: parentNode

| namedNode nameStringNode nodeVersionList contentsVersionList subnodeList parentSubnodeList subnodes |
repository beginTransaction.

"check if name already exists."
parentNode notNil ifTrue: [
   subnodes := self subnodesForNamedNode: parentNode.
   subnodes do: [:each |
       (self nameForNamedNode: each) = name ifTrue: [self halt: 'duplicate named subnode ', name.].
       ].
   ].

namedNode := repository addTriadAbstract.

nameStringNode := repository addTriadString: name.
repository addTriadA: namedNode B: (repository concept: 'has name') C: nameStringNode.

nodeVersionList := repository addTriadAbstract.
repository addTriadA: namedNode B: (repository concept: 'has node version list') C: nodeVersionList.

contentsVersionList := repository addTriadAbstract.
repository addTriadA: namedNode B: (repository concept: 'has contents version list') C: contentsVersionList.

subnodeList := repository addTriadAbstract.
repository addTriadA: namedNode B: (repository concept: 'has subnode list') C: subnodeList.

"first node may not have a parent"
(parentNode notNil and: [parentNode > 0]) ifTrue: [
    parentSubnodeList := self subnodeListForNamedNode: parentNode.
    repository addTriadA: parentSubnodeList B: (repository concept: 'has named node') C: namedNode.].

repository endTransaction.

^namedNode
! !

!PointrelTreeArchiver methodsFor: 'named node creating' stamp: 'pdf 7/3/2000 19:02'!
destroyNamedNode: namedNode

repository markRemoved: namedNode.! !


!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/3/2000 15:33'!
allPossibleSubnodesForNodeVersion: nodeVersion
| namedNode subnodes |
namedNode := self namedNodeForNodeVersion: nodeVersion.
subnodes := self namedNodesInSubnodeList: (self subnodeListForNamedNode: namedNode).
^subnodes
! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/3/2000 20:41'!
currentContentsForNodeVersion: nodeVersion

| contentsVersion |
contentsVersion := self currentContentsVersionForNodeVersion: nodeVersion.
(contentsVersion isNil or: [contentsVersion == 0]) ifTrue: [^''].
^self contentsForContentsVersion: contentsVersion.
! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/3/2000 15:44'!
currentContentsVersionForNodeVersion: nodeVersion

^repository searchForLatestCA: nodeVersion B: (repository concept: 'has current contents version').
! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/4/2000 23:14'!
currentSubnodeVersionTriadsForNodeVersion: nodeVersion

| triads unremovedTriads |
"return a list of values, having made sure triads were not previously removed"
"^repository searchForAllCsA: nodeVersion B: (repository concept: 'has current subnode version')."
triads := repository searchForAllCLinksA: nodeVersion B: (repository concept: 'has current subnode version').
unremovedTriads := triads select: [:each | (repository checkIfMarkedRemoved: each) not].
^unremovedTriads
! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/4/2000 23:15'!
currentSubnodeVersionsForNodeVersion: nodeVersion

^(self currentSubnodeVersionTriadsForNodeVersion: nodeVersion) 
            collect: [:each | repository triadC: each].
! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/4/2000 23:18'!
findSubnodeVersionTriadWithName: name forNodeVersion: nodeVersion
   | subnodeVersion |
  (self currentSubnodeVersionTriadsForNodeVersion: nodeVersion) do: [:each|
         subnodeVersion := self repository triadC: each.
         (self nameForNodeVersion: subnodeVersion) = name ifTrue: [^each].
         ].! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/4/2000 23:21'!
findSubnodeVersionWithName: name forNodeVersion: nodeVersion
  (self currentSubnodeVersionsForNodeVersion: nodeVersion) do: [:each|
         (self nameForNodeVersion: each) = name ifTrue: [^each].
         ].! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/4/2000 23:17'!
nameForNodeVersion: nodeVersion
  ^self nameForNamedNode: (self namedNodeForNodeVersion: nodeVersion)! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/3/2000 15:33'!
namedNodeForNodeVersion: nodeVersion
^ (self namedNodeForNodeVersionList: (self nodeVersionListForNodeVersion: nodeVersion))! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/3/2000 15:46'!
nodeVersionListForNodeVersion: nodeVersion

^repository searchForLatestAB: (repository concept: 'has node version') C: nodeVersion.! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/3/2000 23:54'!
nodeVersionParentForNodeVersion: nodeVersion

"assuming strict hierarchy for now"
^repository searchForLatestAB: (repository concept: 'has current subnode version') C: nodeVersion.! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/3/2000 15:44'!
versionTagForNodeVersion: nodeVersion

^repository searchForLatestCA: nodeVersion B: (repository concept: 'has version tag').! !

!PointrelTreeArchiver methodsFor: 'node version accessing' stamp: 'pdf 7/3/2000 21:18'!
versionTagStringForNodeVersion: nodeVersion

| versionTag |
versionTag := self versionTagForNodeVersion: nodeVersion.
^repository triadString: versionTag.! !


!PointrelTreeArchiver methodsFor: 'node version creating' stamp: 'pdf 7/3/2000 18:25'!
createNodeVersion: versionTag forNamedNode: namedNode

^self createNodeVersion: versionTag forNamedNode: namedNode currentContentsVersion: nil.
! !

!PointrelTreeArchiver methodsFor: 'node version creating' stamp: 'pdf 7/3/2000 18:30'!
createNodeVersion: versionTag forNamedNode: namedNode copyFrom: oldNodeVersion

| contentsVersion subnodeVersions |
contentsVersion := self currentContentsVersionForNodeVersion: oldNodeVersion.
subnodeVersions := self currentSubnodeVersionsForNodeVersion: oldNodeVersion.
^self createNodeVersion: versionTag forNamedNode: namedNode currentContentsVersion: contentsVersion currentSubnodeVersions: subnodeVersions.! !

!PointrelTreeArchiver methodsFor: 'node version creating' stamp: 'pdf 7/3/2000 18:28'!
createNodeVersion: versionTag forNamedNode: namedNode currentContentsVersion: contentsVersion

^self createNodeVersion: versionTag forNamedNode: namedNode currentContentsVersion: contentsVersion currentSubnodeVersions: nil.
! !

!PointrelTreeArchiver methodsFor: 'node version creating' stamp: 'pdf 7/3/2000 23:55'!
createNodeVersion: versionTag forNamedNode: namedNode currentContentsVersion: contentsVersion currentSubnodeVersions: subnodeVersions

| nodeVersion versionTagStringNode namedNodeNodeVersionList |
repository beginTransaction.

nodeVersion := repository addTriadAbstract.

versionTagStringNode := repository addTriadString: versionTag.
repository addTriadA: nodeVersion B: (repository concept: 'has version tag') C: versionTagStringNode.

contentsVersion notNil ifTrue:  [
    repository addTriadA: nodeVersion B: (repository concept: 'has current contents version') C: contentsVersion.
    ].

subnodeVersions notNil ifTrue:  [
    subnodeVersions reverseDo: [:each |
        repository addTriadA: nodeVersion B: (repository concept: 'has current subnode version') C: each.
        ].
    ].

namedNodeNodeVersionList := self nodeVersionListForNamedNode: namedNode.
repository addTriadA: namedNodeNodeVersionList B: (repository concept: 'has node version') C: nodeVersion.

repository endTransaction.

^nodeVersion
! !


!PointrelTreeArchiver methodsFor: 'node version modifying' stamp: 'pdf 7/3/2000 18:37'!
addSubnodeVersion: subnodeVersion forNodeVersion: nodeVersion

repository beginTransaction.

repository addTriadA: nodeVersion B: (repository concept: 'has current subnode version') C: subnodeVersion.

repository endTransaction.

^nodeVersion! !

!PointrelTreeArchiver methodsFor: 'node version modifying' stamp: 'pdf 7/4/2000 07:59'!
freezeNodeVersion: nodeVersion versionTag: versionTag

  repository beginTransaction.
  self setVersionTag: versionTag forNodeVersion: nodeVersion.
  repository addTriadA: nodeVersion B: (repository concept: 'is frozen') C: 0.
  repository endTransaction.! !

!PointrelTreeArchiver methodsFor: 'node version modifying' stamp: 'pdf 7/4/2000 08:25'!
freezeRecursivelyNodeVersion: nodeVersion versionTag: versionTag

   | subnodeVersions |
  "recursive"
   (self isFrozen: nodeVersion) ifTrue: [^self].
  self freezeNodeVersion: nodeVersion versionTag: versionTag.
  subnodeVersions := self currentSubnodeVersionsForNodeVersion: nodeVersion.
  subnodeVersions do: [:each | self freezeRecursivelyNodeVersion: each versionTag: versionTag].! !

!PointrelTreeArchiver methodsFor: 'node version modifying' stamp: 'pdf 7/4/2000 08:22'!
isFrozen: nodeVersion

    | triad |
    triad := repository searchForTriadOrNoneA: nodeVersion B: (repository concept: 'is frozen') C: 0.
    ^triad notNil and: [triad > 0].
! !

!PointrelTreeArchiver methodsFor: 'node version modifying' stamp: 'pdf 7/3/2000 19:01'!
removeSubnodeVersion: subnodeVersion forNodeVersion: nodeVersion

| triad |
triad := repository searchForTriadOrNoneA: nodeVersion B: (repository concept: 'has current subnode version') C: subnodeVersion.
triad isNil ifTrue: [^self halt: 'no such subnodeVersion'].

repository beginTransaction.

repository markRemoved: triad.

repository endTransaction.

^nodeVersion! !

!PointrelTreeArchiver methodsFor: 'node version modifying' stamp: 'pdf 7/3/2000 18:35'!
setContentsVersion: contentsVersion forNodeVersion: nodeVersion

repository beginTransaction.

repository addTriadA: nodeVersion B: (repository concept: 'has current contents version') C: contentsVersion.

repository endTransaction.

^nodeVersion
! !

!PointrelTreeArchiver methodsFor: 'node version modifying' stamp: 'pdf 7/4/2000 07:55'!
setVersionTag: versionTag forNodeVersion: nodeVersion

| versionTagStringNode |
repository beginTransaction.
versionTagStringNode := repository addTriadString: versionTag.
repository addTriadA: nodeVersion B: (repository concept: 'has version tag') C: versionTagStringNode.
repository endTransaction.
! !


!PointrelTreeArchiver methodsFor: 'testing' stamp: 'pdf 7/3/2000 19:14'!
indentForLevel: level
        | result |
        level == 0 ifTrue: [^''].
        result := String new.
        "should use stream"
        1 to: level do: [:i| result := result, '  '].
        ^result
! !

!PointrelTreeArchiver methodsFor: 'testing' stamp: 'pdf 7/3/2000 21:30'!
printNodeVersion: nodeVersion level: level

  | currentSubnodeVersions contentsVersion |
  Transcript show: (self indentForLevel: level).
  Transcript show: 'Node ID: ', nodeVersion printString; cr.
  Transcript show: (self indentForLevel: level).
  Transcript show: 'Node Version: ', (self versionTagStringForNodeVersion: nodeVersion); cr.
  Transcript show: (self indentForLevel: level + 1).
  contentsVersion := self currentContentsVersionForNodeVersion: nodeVersion.
  Transcript show: 'Current contents ID: ', contentsVersion printString; cr.
  Transcript show: (self indentForLevel: level + 1).
  Transcript show: 'version tag: ', (self versionTagForContentsVersion: contentsVersion); cr.
  Transcript show: (self indentForLevel: level + 1).
  Transcript show: 'contents: ', (self contentsForContentsVersion: contentsVersion); cr.
  
  currentSubnodeVersions := self currentSubnodeVersionsForNodeVersion: nodeVersion.
  currentSubnodeVersions do: [:each |
      Transcript show: (self indentForLevel: level + 1).
      Transcript show: 'Current subnode version ID: ', each printString; cr.
      Transcript show: (self indentForLevel: level + 1).
      Transcript show: 'Current subnode version version tag: ', (self versionTagStringForNodeVersion: each); cr.
      ].
! !

!PointrelTreeArchiver methodsFor: 'testing' stamp: 'pdf 7/3/2000 19:16'!
printTree: namedNode
       self printTree: namedNode level: 0.! !

!PointrelTreeArchiver methodsFor: 'testing' stamp: 'pdf 7/3/2000 20:36'!
printTree: namedNode level: level
    | subnodes nodeVersions |
    "use level == 0 to indent from left"
    "recursive"
    Transcript show: (self indentForLevel: level).
    Transcript show: (self nameForNamedNode: namedNode); cr.
    nodeVersions := self nodeVersionsForNamedNode: namedNode.
    nodeVersions do: [:each | self printNodeVersion: each level: level + 1].
    subnodes := self subnodesForNamedNode: namedNode.
    subnodes do: [:each | self printTree: each level: level + 1].

! !


!PointrelTreeArchiver methodsFor: 'accessing' stamp: 'pdf 7/3/2000 20:23'!
repository

^repository! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PointrelTreeArchiver class
	instanceVariableNames: ''!

!PointrelTreeArchiver class methodsFor: 'testing' stamp: 'pdf 7/3/2000 21:28'!
test

"PointrelTreeArchiver test"

| archiver root a1 a2 c1 c2 c3 v1 v2 v3 rc1 rv1 |
"some simple testing of archiving"
archiver := PointrelTreeArchiver new.
root := archiver createNamedNode: 'my test root' asSubnodeOf: nil.
Transcript show: root printString; cr.
a1 := archiver createNamedNode: 'a1' asSubnodeOf: root.
Transcript show: a1 printString; cr.
a2 := archiver createNamedNode: 'a2' asSubnodeOf: root.
Transcript show: a2 printString; cr.
"uncomment next two lines to test duplicate checking"
"a2 := archiver createNamedNode: 'a2' asSubnodeOf: root.
Transcript show: a2 printString; cr."

Transcript show: '----- TREE ------'; cr.
archiver printTree: root.
Transcript show: '----- DONE ------'; cr.

archiver destroyNamedNode: a1.
Transcript show: (archiver repository checkIfMarkedRemoved: a1) printString; cr.

Transcript show: '----- TREE AFTER DESTROY ------'; cr.
archiver printTree: root.
Transcript show: '----- DONE ------'; cr.

a1 := archiver createNamedNode: 'a1' asSubnodeOf: root.
Transcript show: a1 printString; cr.
rc1 := archiver createContentsVersion: 'root version tag 1' contents: 'some contents 1' forNamedNode: root.
rv1 := archiver createNodeVersion: 'root my version 1' forNamedNode: root currentContentsVersion: rc1.

c1 := archiver createContentsVersion: 'version tag 1' contents: 'some contents 1' forNamedNode: a1.
c2 := archiver createContentsVersion: 'version tag 2' contents: 'some contents 2' forNamedNode: a1.
c3 := archiver createContentsVersion: 'version tag 3' contents: 'some contents 3' forNamedNode: a1.
v1 := archiver createNodeVersion: 'my version 1' forNamedNode: a1 currentContentsVersion: c1.
v2 := archiver createNodeVersion: 'my version 2' forNamedNode: a1 currentContentsVersion: c2.
v3 := archiver createNodeVersion: 'my version 3' forNamedNode: a1 copyFrom: v1.
archiver addSubnodeVersion: v3 forNodeVersion: rv1.

Transcript show: '----- TREEAFTER RE-ADD A1 and versions------'; cr.
archiver printTree: root.
Transcript show: '----- DONE ------'; cr.
! !


!PointrelTreeArchiver class methodsFor: 'instance creating' stamp: 'pdf 7/3/2000 15:02'!
new
^super new initialize! !
